/* subtract data from A to B*/
/* the usage is 'img_rati file1 file2 file3' */
/* file3 = (file1/file2) * 10000 */

#include<io.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>

#define INTEL

#define HiPic_Header_Size 64

struct hipic_header
//typedef struct
{
	char				head[2];
	unsigned short		comment_length;
	unsigned short		width;
	unsigned short		height;
	unsigned short		x_offset;
	unsigned short		y_offset;
	unsigned short		type;
	char				reserved[63 - 13];
	char				*comment;
} HiPic_Header;

static	FILE *fi1, *fi2, *fo;

void	main(argc,argv)
int		argc;
char	*argv[];
{
//  HiPic_Header    header;
	short			*image1, *image2, *outimg;
	int				x_size1, y_size1, x_size2, y_size2;
	long			i, jj;

		if(argc < 3)   // when bad number of parameters
		{
			printf("The usage is 'img_rati file1 file2 file3'\n");
			printf("file3 = (file1/file2) * 2000 \n");
			exit(-1);
		}
//open input files
		if((fi1 = fopen(argv[1],"rb")) == NULL) // file1 open
			{ printf("can not open file1 for input\n"); exit(-1);}
		if((fi2 = fopen(argv[2],"rb")) == NULL) // file2 open
			{ printf("can not open file2 for input\n"); exit(-1);}
		if((fo  = fopen(argv[3],"wb")) == NULL) // file3 open
			{ printf("can not open file3 for output\n"); exit(-1);}

// read comment and image data from file1
		if (fread(&HiPic_Header, sizeof(char), HiPic_Header_Size, fi1) != HiPic_Header_Size)
			{ fprintf(stderr, "EOF in %s (header)\n", argv[1]); exit(-1);}
		if (strncmp(HiPic_Header.head, "IM", 2))
			{ fprintf(stderr, "This is not HiPIc image file.\n"); exit(-1);}

		HiPic_Header.comment = (char *) malloc(HiPic_Header.comment_length + 1);
		if (HiPic_Header.comment == NULL)
			{ fprintf(stderr, "Connot allocate memory (HiPic_Header.comment)\n"); exit(-1);}
		if (fread(HiPic_Header.comment, sizeof(char), HiPic_Header.comment_length, fi1) != HiPic_Header.comment_length)
			{ fprintf(stderr, "EOF found (comment)\n"); exit(-1);}
		x_size1 = HiPic_Header.width;  printf("x_size1         %d \n", x_size1);
		y_size1 = HiPic_Header.height; printf("y_size1         %d \n", y_size1);
		printf("comment length1 %d \n\n", HiPic_Header.comment_length);

		image1 = (short *) malloc(x_size1 * y_size1 * sizeof(short));
		if ((i = fread( image1, sizeof(short), x_size1 * y_size1, fi1)) != x_size1 * y_size1)
			{ fprintf(stderr, "EOF found in the data of %s (%d %d) \n", argv[1], i, x_size1*y_size1); exit(-1);}

// read comment and image data from file2
		if (fread(&HiPic_Header, sizeof(char), HiPic_Header_Size, fi2) != HiPic_Header_Size)
			{ fprintf(stderr, "EOF in %s (header)\n", argv[2]); exit(-1);}
		if (strncmp(HiPic_Header.head, "IM", 2))
			{ fprintf(stderr, "2This is not HiPIc image file.\n"); exit(-1);}

		HiPic_Header.comment = (char *) malloc(HiPic_Header.comment_length + 1);
		if (HiPic_Header.comment == NULL)
			{ fprintf(stderr, "Connot allocate memory (HiPic_Header.comment)\n"); exit(-1);}
		if (fread(HiPic_Header.comment, sizeof(char), HiPic_Header.comment_length, fi2) != HiPic_Header.comment_length)
			{ fprintf(stderr, "EOF found (comment)\n"); exit(-1);}
		x_size2 = HiPic_Header.width;  printf("x_size2         %d \n", x_size2);
		y_size2 = HiPic_Header.height; printf("y_size2         %d \n", y_size2);
		printf("comment length2 %d \n\n", HiPic_Header.comment_length);

		image2 = (short *) malloc(x_size2 * y_size2 *sizeof(short));
		if ((i = fread( image2, sizeof(short), x_size2 * y_size2, fi2)) != x_size2 * y_size2)
			{ fprintf(stderr, "EOF found in the data of %s (%d %d) \n", argv[1], i, x_size2*y_size2); exit(-1);}

		if (fwrite(&HiPic_Header, sizeof(char), HiPic_Header_Size, fo) != HiPic_Header_Size)
			{ fprintf(stderr, "something wrong in %s (header)\n", argv[3]); exit(-1);}
		if (fwrite(HiPic_Header.comment, sizeof(char), HiPic_Header.comment_length, fo) != HiPic_Header.comment_length)
			{ fprintf(stderr, "something wrong in comment of %s (header)\n", argv[3]); exit(-1);}

// average of dark data
		outimg = (short *) malloc(x_size2 * y_size2 * sizeof(short));
		for(jj = 0; jj < x_size2 * y_size2 ; ++ jj)
		{
			*(outimg+jj) = (short)(2000 * ((double)*(image1+jj) /(double) *(image2+jj)));
		}

// write comment and dark image to file3
		if (i = fwrite(outimg , sizeof(short), x_size2 * y_size2, fo) > x_size2 * y_size2 * sizeof(short))
			{ fprintf(stderr, "something wrong in data area %d  %d\n", i, x_size2 * y_size2); exit(-1);}

// close files
		fclose(fi1);
		fclose(fi2);
		fclose(fo);

//  printf("-------------------------------\n");
//  printf("%s\n", HiPic_Header.head);
//  printf("%d\n", HiPic_Header.comment_length);
//  printf("%d\n", HiPic_Header.width);
//  printf("%d\n", HiPic_Header.height);
//  printf("%d\n", HiPic_Header.x_offset);
//  printf("%d\n", HiPic_Header.y_offset);
//  printf("%d\n", HiPic_Header.type);
//  printf("%s\n", HiPic_Header.reserved);
//  printf("%s\n", HiPic_Header.comment);
//  printf("-------------------------------\n");

//fin:
	free(HiPic_Header.comment);
	free(image1);
	free(image2);
	free(outimg);
	exit(0);
}

